// This file is generated.

// Copyright 2018 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

package com.mapmyindia.mapmyindiagl;

import com.mapbox.mapboxsdk.geometry.LatLng;
import com.mapmyindia.sdk.plugin.annotation.Fill;
import com.mapmyindia.sdk.plugin.annotation.FillManager;
import com.mapmyindia.sdk.plugin.annotation.FillOptions;

import java.util.List;

class FillBuilder implements FillOptionsSink {
  private final FillManager fillManager;
  private final FillOptions fillOptions;

  FillBuilder(FillManager fillManager) {
    this.fillManager = fillManager;
    this.fillOptions = new FillOptions();
  }

  public FillOptions getFillOptions(){
    return this.fillOptions;
  }

  Fill build() {
    return fillManager.create(fillOptions);
  }

  @Override
  public void setFillOpacity(float fillOpacity) {
    fillOptions.fillOpacity(fillOpacity);
  }

  @Override
  public void setFillColor(String fillColor) {
    fillOptions.fillColor(fillColor);
  }

  @Override
  public void setFillOutlineColor(String fillOutlineColor) {
    fillOptions.fillOutlineColor(fillOutlineColor);
  }

  @Override
  public void setFillPattern(String fillPattern) {
    fillOptions.fillPattern(fillPattern);
  }

  @Override
  public void setGeometry(List<List<LatLng>> geometry) {
    fillOptions.geometry(Convert.interpretListLatLng(geometry));
  }

  @Override
  public void setDraggable(boolean draggable) {
    fillOptions.draggable(draggable);
  }
}