// Copyright 2018 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

library mapmyindia_gl;

import 'dart:async';
import 'dart:math';
import 'dart:typed_data';
import 'dart:convert';

import 'package:flutter/foundation.dart';
import 'package:flutter/gestures.dart';
import 'package:flutter/material.dart';
import 'package:flutter/services.dart';
import 'src/keys.dart' as keys;
import 'src/api/mapmyindia_api_platform_interface.dart' as restApi;
import 'package:mapmyindia_gl_platform_interface/mapmyindia_gl_platform_interface.dart';
import 'package:flutter/cupertino.dart';

export 'package:mapmyindia_gl_platform_interface/mapmyindia_gl_platform_interface.dart'
    show
        LatLng,
        LatLngBounds,
        LatLngQuad,
        CameraPosition,
        CameraUpdate,
        ArgumentCallbacks,
        Symbol,
        SymbolOptions,
        CameraTargetBounds,
        MinMaxZoomPreference,
        MapboxStyles,
        MyLocationTrackingMode,
        MyLocationRenderMode,
        CompassViewPosition,
        Circle,
        CircleOptions,
        Line,
        LineOptions,
        Fill,
        FillOptions;

part 'src/controller.dart';
part 'src/mapmyindia_map.dart';
part 'src/global.dart';
part 'src/mapmyindia_account_manager.dart';
part 'src/api/autosuggest/mapmyindia_autosuggest.dart';
part 'src/api/autosuggest/autosuggest_response.dart';
part 'src/api/autosuggest/autosuggest_criteria.dart';
part 'src/api/geocoding/mapmyindia_geocoding.dart';
part 'src/api/geocoding/geocode_response.dart';
part 'src/api/geocoding/gocoding_criteria.dart';
part 'src/api/reversegeocode/mapmyindia_reverse_geocode.dart';
part 'src/api/reversegeocode/place_response.dart';
part 'src/api/nearby/mapmyindia_nearby.dart';
part 'src/api/nearby/nearby_response.dart';
part 'src/api/nearby/nearby_criteria.dart';
part 'src/api/direction/mapmyindia_direction.dart';
part 'src/api/direction/direction_criteria.dart';
part 'src/api/direction/direction_response.dart';
part 'src/api/direction/leg_step.dart';
part 'src/api/direction/route_options.dart';
part 'src/api/distance/mapmyindia_distance.dart';
part 'src/api/distance/distance_criteria.dart';
part 'src/api/distance/distance_response.dart';
part 'src/api/feedback/mapmyindia_feedback.dart';
part 'src/api/poialongroute/mapmyindia_poi_along_route.dart';
part 'src/api/poialongroute/poi_criteria.dart';
part 'src/api/poialongroute/poi_along_route_response.dart';
part 'src/api/textsearch/mapmyindia_text_search.dart';
part 'src/api/place_detail/mapmyindia_place_detail.dart';
part 'src/api/place_detail/place_detail_response.dart';
part 'src/api/place_detail/place_detail_legacy_response.dart';
