part of mapmyindia_gl;

class MapmyIndiaAutoSuggest {
  final String query;
  final String? filter;
  final bool? bridge;
  final String? pod;
  final LatLng? location;
  final bool? tokenizeAddress;
  final double? zoom;

  MapmyIndiaAutoSuggest({
    required this.query,
    this.filter,
    this.bridge,
    this.pod,
    this.location,
    this.tokenizeAddress,
    this.zoom
  });

  Map<String, dynamic> toMap() {
    final Map<String, dynamic> optionsMap = <String, dynamic>{};

    void addIfNonNull(String fieldName, dynamic value) {
      if (value != null) {
        optionsMap[fieldName] = value;
      }
    }

    addIfNonNull('query', query);
    addIfNonNull('filter', filter);
    addIfNonNull('bridge', bridge);
    addIfNonNull('pod', pod);
    addIfNonNull('location', location?.toJson());
    addIfNonNull('tokenizeAddress', tokenizeAddress);
    addIfNonNull('zoom', zoom);

    return optionsMap;
  }

  Future<AutoSuggestResponse?> callAutoSuggest() async {
    try {
      String? result = await restApi.autoSuggest(toMap());
      return result != null
          ? AutoSuggestResponse.fromMap(json.decode(result))
          : null;
    } on PlatformException catch(e) {
      return Future.error(e);
    }
  }
}
