part of mapmyindia_gl;

class DistanceResponse {
  int? responseCode;
  String? version;
  DistanceResults? results;

  static DistanceResponse fromMap(Map<String, dynamic> map) {
    DistanceResponse distanceResponseBean = DistanceResponse();
    distanceResponseBean.responseCode = map['responseCode'];
    distanceResponseBean.version = map['version'];
    distanceResponseBean.results = DistanceResults.fromMap(map['results']);
    return distanceResponseBean;
  }

  Map toJson() => {
    "responseCode": responseCode,
    "version": version,
    "results": results?.toJson(),
  };
}

/// code : "Ok"
/// distances : [[0,6817.7,20475.7]]
/// durations : [[0,1844.4,5307.5]]

class DistanceResults {
  String? code;
  List<List<double>>? distances;
  List<List<double>>? durations;

  static DistanceResults fromMap(Map<String, dynamic> map) {
    DistanceResults resultsBean = DistanceResults();
    resultsBean.code = map['code'];
    if(map.containsKey('distances')) {
      List<dynamic> distances = map['distances'];
      resultsBean.distances = List.generate( distances.length, (index) {
        List<dynamic> list = distances[index];
        return List.generate(list.length, (index) => list[index] as double);
      });
    }
    if(map.containsKey('durations')) {
      List<dynamic> durations = map['durations'];
      resultsBean.durations = List.generate( durations.length, (index) {
        List<dynamic> list = durations[index];
        return List.generate(list.length, (index) => list[index] as double);
      });
    }

    return resultsBean;
  }
  Map<String, dynamic> toJson() {
    final Map<String, dynamic> map = <String, dynamic>{};

    void addIfNonNull(String fieldName, dynamic value) {
      if (value != null) {
        map[fieldName] = value;
      }
    }
    addIfNonNull('code', code);
    addIfNonNull('distances', distances);
    addIfNonNull('durations', durations);

    return map;
  }
}