part of mapmyindia_gl;

class MapmyIndiaDistanceMatrix {
  final List<String> sources;
  final List<String> destinations;
  final String profile;
  final String resource;
  final int? routeType;

  MapmyIndiaDistanceMatrix({
    required this.sources,
    required this.destinations,
    this.routeType,
    this.profile = DistanceCriteria.PROFILE_DRIVING,
    this.resource = DistanceCriteria.RESOURCE_DISTANCE,
  });

  Map<String, dynamic> toMap() {
    final Map<String, dynamic> optionsMap = <String, dynamic>{};

    void addIfNonNull(String fieldName, dynamic value) {
      if (value != null) {
        optionsMap[fieldName] = value;
      }
    }

    addIfNonNull('profile', profile);
    addIfNonNull('resource', resource);
    addIfNonNull('routeType', routeType);

    if (sources.length > 1) {
      int i = 0;
      List<int> sourceIndex = [];
      List<int> destinationIndex = [];
      for (int index = 0; index < sources.length; index++) {
        sourceIndex.add(i);
        i++;
      }

      for (int index = 0; index < destinations.length; index++) {
        destinationIndex.add(i);
        i++;
      }

      addIfNonNull('sources', sourceIndex);
      addIfNonNull('destinations', destinationIndex);
    }

    List<String> coordinateList = [];
    sources.forEach((element) {
      coordinateList.add(element);
    });
    destinations.forEach((element) {
      coordinateList.add(element);
    });
    addIfNonNull('coordinates', coordinateList);
    return optionsMap;
  }

  Future<DistanceResponse?> callDistanceMatrix() async {
    try {
      String? result = await restApi.distanceMatrix(toMap());
      return result != null
          ? DistanceResponse.fromMap(json.decode(result))
          : null;
    } on PlatformException catch (e) {
      return Future.error(e);
    }
  }
}
