part of mapmyindia_gl;

class MapmyIndiaFeedback {
  final String typedKeyword;
  final String eLoc;
  final String appVersion;
  final int index;
  final LatLng location;
  final String? locationName;
  final String? userName;

  MapmyIndiaFeedback(
      {required this.typedKeyword,
      required this.eLoc,
      required this.index,
      required this.appVersion,
      required this.location,
      this.locationName,
      this.userName});

  Map<String, dynamic> toMap() {
    final Map<String, dynamic> optionsMap = <String, dynamic>{};

    void addIfNonNull(String fieldName, dynamic value) {
      if (value != null) {
        optionsMap[fieldName] = value;
      }
    }

    addIfNonNull('typedKeyword', this.typedKeyword);
    addIfNonNull('eLoc', this.eLoc);
    addIfNonNull('index', this.index);
    addIfNonNull('appVersion', this.appVersion);
    addIfNonNull('location', this.location.toJson());
    addIfNonNull('locationName', this.locationName);
    addIfNonNull('userName', this.userName);

    return optionsMap;
  }

  Future<int?> callFeedback() async {
    try {
      return await restApi.feedback(toMap());
    } on PlatformException catch (e) {
      return Future.error(e);
    }
  }
}
