part of mapmyindia_gl;

class GeocodeResponse {
  List<GeoCodeResult>? results;

  static GeocodeResponse fromMap(Map<String, dynamic> map) {
    GeocodeResponse geocodeResponse = GeocodeResponse();
    if (map.containsKey('results')) {
      List<dynamic> results = map['results'] as List<dynamic>;
      geocodeResponse.results = List.generate(results.length, (index) {
        return GeoCodeResult.fromMap(results[index] as Map<String, dynamic>);
      });
    }
    return geocodeResponse;
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> map = <String, dynamic>{};

    if (this.results != null) {
      map['results'] = List.generate(this.results!.length, (index) {
        return this.results![index].toJson();
      });
    }
    return map;
  }
}

class GeoCodeResult {
  String? houseNumber;
  String? houseName;
  String? poi;
  String? street;
  String? subSubLocality;
  String? subLocality;
  String? locality;
  String? village;
  String? subDistrict;
  String? district;
  String? city;
  String? state;
  String? pincode;
  String? formattedAddress;
  String? eLoc;
  double? latitude;
  double? longitude;
  String? geocodeLevel;

  static GeoCodeResult fromMap(Map<String, dynamic> map) {
    GeoCodeResult result = GeoCodeResult();
    result.houseNumber = map['houseNumber'];
    result.houseName = map['houseName'];
    result.poi = map['poi'];
    result.street = map['street'];
    result.subSubLocality = map['subSubLocality'];
    result.subLocality = map['subLocality'];
    result.locality = map['locality'];
    result.village = map['village'];
    result.subDistrict = map['subDistrict'];
    result.district = map['district'];
    result.city = map['city'];
    result.state = map['state'];
    result.pincode = map['pincode'];
    result.formattedAddress = map['formattedAddress'];
    result.eLoc = map['eLoc'];
    result.latitude = map['latitude'];
    result.longitude = map['longitude'];
    result.geocodeLevel = map['geocodeLevel'];
    return result;
  }

  Map toJson() => {
        "houseNumber": houseNumber,
        "houseName": houseName,
        "poi": poi,
        "street": street,
        "subSubLocality": subSubLocality,
        "subLocality": subLocality,
        "locality": locality,
        "village": village,
        "subDistrict": subDistrict,
        "district": district,
        "city": city,
        "state": state,
        "pincode": pincode,
        "formattedAddress": formattedAddress,
        "eLoc": eLoc,
        "latitude": latitude,
        "longitude": longitude,
        "geocodeLevel": geocodeLevel,
      };
}
