part of mapmyindia_gl;

class MapmyIndiaGeoCoding {
  final String address;
  final int? bias;
  final int? itemCount;
  final String? podFilter;
  final String? bound;

  MapmyIndiaGeoCoding(
      {required this.address, this.bias, this.itemCount, this.podFilter, this.bound});

  Map<String, dynamic> toMap() {
    final Map<String, dynamic> optionsMap = <String, dynamic>{};

    void addIfNonNull(String fieldName, dynamic value) {
      if (value != null) {
        optionsMap[fieldName] = value;
      }
    }

    addIfNonNull('address', address);
    addIfNonNull('bias', bias);
    addIfNonNull('itemCount', itemCount);
    addIfNonNull('podFilter', podFilter);
    addIfNonNull('bound', bound);
    return optionsMap;
  }

  Future<GeocodeResponse?> callGeocoding() async {
    try {
    String? result = await restApi.geocode(toMap());
    return result != null ? GeocodeResponse.fromMap(json.decode(result)): null;
  } on PlatformException catch (e) {
    return Future.error(e);
  }
  }
}
