part of mapmyindia_gl;

class MapmyIndiaNearby {
  final String keyword;
  final LatLng? location;
  final String? eLoc;
  final int? page;
  final int? radius;
  final String? pod;
  final String? bounds;
  final String? filter;
  final bool? explain;
  final bool? richData;
  final String? searchBy;
  final String? sortBy;
  final String? userName;

  MapmyIndiaNearby(
      {required this.keyword,
      this.location,
      this.eLoc,
      this.page,
      this.radius,
      this.pod,
      this.bounds,
      this.filter,
      this.explain,
      this.richData,
      this.searchBy,
      this.sortBy,
      this.userName})
      : assert(location != null || eLoc != null);

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> optionsMap = <String, dynamic>{};

    void addIfNonNull(String fieldName, dynamic value) {
      if (value != null) {
        optionsMap[fieldName] = value;
      }
    }

    addIfNonNull('keyword', keyword);
    addIfNonNull('location', location?.toJson());
    addIfNonNull('eLoc', eLoc);
    addIfNonNull('page', page);
    addIfNonNull('radius', radius);
    addIfNonNull('pod', pod);
    addIfNonNull('bounds', bounds);
    addIfNonNull('filter', filter);
    addIfNonNull('explain', explain);
    addIfNonNull('richData', richData);
    addIfNonNull('searchBy', searchBy);
    addIfNonNull('sortBy', sortBy);
    addIfNonNull('userName', userName);

    return optionsMap;
  }

  Future<NearbyResponse?> callNearby() async {
    try {
      String? result = await restApi.nearby(toJson());
      return result != null
          ? NearbyResponse.fromMap(json.decode(result))
          : null;
    } on PlatformException catch (e) {
      return Future.error(e);
    }
  }
}
