part of mapmyindia_gl;

class MapmyIndiaPlaceDetail {
  final String eLoc;

  MapmyIndiaPlaceDetail({required this.eLoc});

  Map<String, dynamic> toMap() {
    final Map<String, dynamic> optionsMap = <String, dynamic>{};

    void addIfNonNull(String fieldName, dynamic value) {
      if (value != null) {
        optionsMap[fieldName] = value;
      }
    }

    addIfNonNull('eLoc', eLoc);

    return optionsMap;
  }

  Future<PlaceDetailResponse?> callPlaceDetail() async {
    try {
      String? result = await restApi.placeDetail(toMap());
      return result != null
          ? PlaceDetailResponse.fromMap(json.decode(result))
          : null;
    } on PlatformException catch (e) {
      return Future.error(e);
    }
  }

  @deprecated
  Future<PlaceDetailLegacyResponse?> callPlaceDetailLegacy() async {
    try {
    String? result = await restApi.placeDetailLegacy(toMap());
    return result != null
        ? PlaceDetailLegacyResponse.fromMap(json.decode(result))
        : null;
  } on PlatformException catch (e) {
  return Future.error(e);
  }
  }
}
