part of mapmyindia_gl;

class PlaceDetailResponse {
  String? eLoc;
  double? latitude;
  double? longitude;
  String? placeName;
  String? address;
  String? type;
  String? houseNumber;
  String? houseName;
  String? poi;
  String? street;
  String? subSubLocality;
  String? subLocality;
  String? locality;
  String? village;
  String? district;
  String? subDistrict;
  String? city;
  String? state;
  String? pincode;
  List<PlaceInfo>? placeInfo;

  static PlaceDetailResponse fromMap(Map<String, dynamic> map) {
    PlaceDetailResponse placeDetailResponse = PlaceDetailResponse();
    placeDetailResponse.eLoc = map['eloc'];
    placeDetailResponse.latitude = map['latitude'];
    placeDetailResponse.longitude = map['longitude'];
    placeDetailResponse.placeName = map['placeName'];
    placeDetailResponse.address = map['address'];
    placeDetailResponse.type = map['type'];
    placeDetailResponse.houseNumber = map['houseNumber'];
    placeDetailResponse.houseName = map['houseName'];
    placeDetailResponse.poi = map['poi'];
    placeDetailResponse.street = map['street'];
    placeDetailResponse.subSubLocality = map['subSubLocality'];
    placeDetailResponse.subLocality = map['subLocality'];
    placeDetailResponse.locality = map['locality'];
    placeDetailResponse.village = map['village'];
    placeDetailResponse.district = map['district'];
    placeDetailResponse.subDistrict = map['subDistrict'];
    placeDetailResponse.city = map['city'];
    placeDetailResponse.state = map['state'];
    placeDetailResponse.pincode = map['pincode'];
    if (map.containsKey('placeKeyInfo')) {
      List<dynamic> list = map['placeKeyInfo'];
      placeDetailResponse.placeInfo =
          List.generate(list.length, (index) => PlaceInfo.fromMap(list[index]));
    }
    return placeDetailResponse;
  }

  Map<String, dynamic> toJson() {
    Map<String, dynamic> map = {
      "eloc": eLoc,
      "latitude": latitude,
      "longitude": longitude,
      "placeName": placeName,
      "address": address,
      "type": type,
      "houseNumber": houseNumber,
      "houseName": houseName,
      "poi": poi,
      "street": street,
      "subSubLocality": subSubLocality,
      "subLocality": subLocality,
      "locality": locality,
      "village": village,
      "district": district,
      "subDistrict": subDistrict,
      "city": city,
      "state": state,
      "pincode": pincode,
    };
    if (placeInfo != null) {
      map['placeKeyInfo'] = List.generate(
          placeInfo!.length, (index) => placeInfo![index].toJson());
    }
    return map;
  }
}

class PlaceInfo {
  String? heading;
  List<PlaceInfoValue>? values;

  static PlaceInfo fromMap(Map<String, dynamic> map) {
    PlaceInfo placeInfo = PlaceInfo();
    placeInfo.heading = map['heading'];
    if (map.containsKey('values')) {
      List<dynamic> list = map['values'];
      placeInfo.values = List.generate(
          list.length, (index) => PlaceInfoValue.fromMap(list[index]));
    }
    return placeInfo;
  }

  Map<String, dynamic> toJson() {
    Map<String, dynamic> map = {};
    map['heading'] = heading;
    if (values != null) {
      map['values'] =
          List.generate(values!.length, (index) => values![index].toJson());
    }
    return map;
  }
}

class PlaceInfoValue {
  String? title;
  String? value;

  static PlaceInfoValue fromMap(Map<String, dynamic> map) {
    PlaceInfoValue placeInfo = PlaceInfoValue();
    placeInfo.title = map['title'];
    placeInfo.value = map['value'];

    return placeInfo;
  }

  Map<String, dynamic> toJson() {
    Map<String, dynamic> map = {};
    map['title'] = title;
    map['value'] = value;
    return map;
  }
}
