part of mapmyindia_gl;

class MapmyIndiaPOIAlongRoute {
  final String path;
  final String category;
  final String geometries;
  final int? buffer;
  final int? page;
  final bool? sort;

  MapmyIndiaPOIAlongRoute(
      {required this.path,
      required this.category,
      this.buffer,
      this.page,
      this.sort,
      this.geometries = POICriteria.GEOMETRY_POLYLINE6});

  Map<String, dynamic> toMap() {
    final Map<String, dynamic> optionsMap = <String, dynamic>{};

    void addIfNonNull(String fieldName, dynamic value) {
      if (value != null) {
        optionsMap[fieldName] = value;
      }
    }

    addIfNonNull('path', path);
    addIfNonNull('category', category);
    addIfNonNull('geometries', geometries);
    addIfNonNull('buffer', buffer);
    addIfNonNull('page', page);
    addIfNonNull('sort', sort);
    return optionsMap;
  }

  Future<PoiAlongRouteResponse?> callPOIAlongRoute() async {
    try {
      String? result = await restApi.poiAlongRoute(toMap());
      return result != null
          ? PoiAlongRouteResponse.fromMap(json.decode(result))
          : null;
    } on PlatformException catch (e) {
      return Future.error(e);
    }
  }
}
