part of mapmyindia_gl;

class PoiAlongRouteResponse {
  List<SuggestedPOI>? suggestedPOIs;

  static PoiAlongRouteResponse fromMap(Map<String, dynamic> map) {
    PoiAlongRouteResponse poiAlongRouteResponseBean = PoiAlongRouteResponse();
    if (map.containsKey('suggestedPOIs')) {
      List<dynamic> list = map['suggestedPOIs'];
      poiAlongRouteResponseBean.suggestedPOIs = List.generate(
          list.length, (index) => SuggestedPOI.fromMap(list[index]));
    }
    return poiAlongRouteResponseBean;
  }

  Map toJson() {
    Map<String, dynamic> map = {};
    if (suggestedPOIs != null) {
      map['suggestedPOIs'] = List.generate(
          suggestedPOIs!.length, (index) => suggestedPOIs![index].toJson());
    }
    return map;
  }
}

class SuggestedPOI {
  int? distance;
  String? placeId;
  String? poi;
  String? subSubLocality;
  String? subLocality;
  String? locality;
  String? city;
  String? subDistrict;
  String? district;
  String? state;
  String? popularName;
  String? address;
  String? telephoneNumber;
  String? email;
  String? website;
  double? longitude;
  double? latitude;
  double? entryLatitude;
  double? entryLongitude;
  String? category;
  String? brandCode;

  static SuggestedPOI fromMap(Map<String, dynamic> map) {
    SuggestedPOI suggestedPOIsBean = SuggestedPOI();
    suggestedPOIsBean.distance = map['distance'];
    suggestedPOIsBean.placeId = map['place_id'];
    suggestedPOIsBean.poi = map['poi'];
    suggestedPOIsBean.subSubLocality = map['subSubLocality'];
    suggestedPOIsBean.subLocality = map['subLocality'];
    suggestedPOIsBean.locality = map['locality'];
    suggestedPOIsBean.city = map['city'];
    suggestedPOIsBean.subDistrict = map['subDistrict'];
    suggestedPOIsBean.district = map['district'];
    suggestedPOIsBean.state = map['state'];
    suggestedPOIsBean.popularName = map['poplrName'];
    suggestedPOIsBean.address = map['address'];
    suggestedPOIsBean.telephoneNumber = map['tel'];
    suggestedPOIsBean.email = map['email'];
    suggestedPOIsBean.website = map['website'];
    suggestedPOIsBean.longitude = map['longitude'];
    suggestedPOIsBean.latitude = map['latitude'];
    suggestedPOIsBean.entryLongitude = map['e_lng'];
    suggestedPOIsBean.entryLatitude = map['e_lat'];
    suggestedPOIsBean.category = map['category'];
    suggestedPOIsBean.brandCode = map['brand_code'];
    return suggestedPOIsBean;
  }

  Map toJson() =>
      {
        "distance": distance,
        "place_id": placeId,
        "poi": poi,
        "subSubLocality": subSubLocality,
        "subLocality": subLocality,
        "locality": locality,
        "city": city,
        "subDistrict": subDistrict,
        "district": district,
        "state": state,
        "poplrName": popularName,
        "address": address,
        "tel": telephoneNumber,
        "email": email,
        "website": website,
        "longitude": longitude,
        "latitude": latitude,
        "e_lng": entryLongitude,
        "e_lat": entryLatitude,
        "category": category,
        "brand_code": brandCode,
      };
}
