part of mapmyindia_gl;

class MapmyIndiaReverseGeocode {
  final LatLng location;

  MapmyIndiaReverseGeocode({required this.location});

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> optionsMap = <String, dynamic>{};

    void addIfNonNull(String fieldName, dynamic value) {
      if (value != null) {
        optionsMap[fieldName] = value;
      }
    }
    addIfNonNull('location', location.toJson());

    return optionsMap;
  }

  Future<ReverseGeocodeResponse?> callReverseGeocode() async {
    try {
    String? result = await restApi.revGeocode(toJson());
    return result != null ? ReverseGeocodeResponse.fromMap(json.decode(result)): null;
  } on PlatformException catch (e) {
  return Future.error(e);
  }
  }

}