part of mapmyindia_gl;

class MapmyIndiaTextSearch {
  final String query;
  final String? filter;
  final bool? bridge;
  final String? pod;
  final LatLng? location;
  final bool? explain;
  final String? username;

  MapmyIndiaTextSearch(
      {required this.query,
      this.filter,
      this.bridge,
      this.pod,
      this.location,
      this.explain,
      this.username});

  Map<String, dynamic> toMap() {
    final Map<String, dynamic> optionsMap = <String, dynamic>{};

    void addIfNonNull(String fieldName, dynamic value) {
      if (value != null) {
        optionsMap[fieldName] = value;
      }
    }

    addIfNonNull('query', query);
    addIfNonNull('filter', filter);
    addIfNonNull('bridge', bridge);
    addIfNonNull('pod', pod);
    addIfNonNull('location', location?.toJson());
    addIfNonNull('explain', explain);
    addIfNonNull('username', username);

    return optionsMap;
  }

  Future<AutoSuggestResponse?> callTextSearch() async {
    try {
      String? result = await restApi.textSearch(toMap());
      return result != null
          ? AutoSuggestResponse.fromMap(json.decode(result))
          : null;
    } on PlatformException catch (e) {
      return Future.error(e);
    }
  }
}
